<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.notifications"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <div *ngIf="readonly"
         class="header"
    >
      <solidify-status *ngIf="getFormControl(formDefinition.notificationCategory).value === notificationCategoryEnum.REQUEST"
                       [statusModel]="enumUtil.getKeyValue(listNotificationStatusTranslate, getFormControl(formDefinition.notificationStatus).value)"
      ></solidify-status>
    </div>

    <mat-form-field *ngIf="getFormControl(formDefinition.notificationCategory) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.category | translate}}</mat-label>
      <mat-select [formControl]="fd"
      >
        <mat-option *ngFor="let category of listNotificationCategory"
                    [value]="category.key"
                    solidifyTooltipOnEllipsis
        >
          {{category.value | translate}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.notificationType) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.type | translate}}</mat-label>
      <mat-select [formControl]="fd"
      >
        <mat-option *ngFor="let type of listNotificationType"
                    [value]="type.key"
                    solidifyTooltipOnEllipsis
        >
          {{type.value | translate}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <ng-container *ngIf="getFormControl(formDefinition.notifiedOrgUnitId) as fd">
      <solidify-searchable-single-select (navigate)="navigateToOrgUnit($event)"
                                         *ngIf="fd.value | isNotNullNorUndefined"
                                         [formControl]="fd"
                                         [isWithLink]="true"
                                         [labelKey]="'name'"
                                         [placeholder]="labelTranslateEnum.notifiedOrganizationalUnit | translate"
                                         [readonly]="true"
                                         [required]="formValidationHelper.hasRequiredField(fd)"
                                         [resourceNameSpace]="sharedOrgUnitActionNameSpace"
                                         [state]="sharedOrganizationalUnitState"
                                         [valueKey]="'resId'"
                                         solidifyValidation
      >
      </solidify-searchable-single-select>
    </ng-container>

    <ng-container *ngIf="getFormControl(formDefinition.emitterId) as fd">
      <solidify-searchable-single-select (navigate)="navigateToPerson($event)"
                                         *ngIf="fd.value | isNotNullNorUndefined"
                                         [formControl]="fd"
                                         [isWithLink]="securityService.isRootOrAdmin()"
                                         [labelKey]="'fullName'"
                                         [placeholder]="labelTranslateEnum.emitter | translate"
                                         [readonly]="true"
                                         [required]="formValidationHelper.hasRequiredField(fd)"
                                         [resourceNameSpace]="sharedPersonActionNameSpace"
                                         [state]="sharedPersonState"
                                         [valueKey]="'resId'"
                                         solidifyValidation
      >
      </solidify-searchable-single-select>
    </ng-container>

    <ng-container *ngIf="getFormControl(formDefinition.emitterEmail) as fd">
      <mat-form-field *ngIf="fd.value | isNonEmptyString"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.emitterEmail | translate }}</mat-label>
        <input [formControl]="fd"
               matInput
        >
      </mat-form-field>
    </ng-container>

    <mat-form-field *ngIf="getFormControl(formDefinition.message) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.message | translate }}</mat-label>
      <textarea [formControl]="fd"
                [required]="formValidationHelper.hasRequiredField(fd)"
                [solidifyValidation]="errors"
                cdkAutosizeMaxRows="10"
                cdkAutosizeMinRows="5"
                cdkTextareaAutosize
                matInput
      ></textarea>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <ng-container *ngIf="getFormControl(formDefinition.responseMessage) as fd">
      <mat-form-field
        *ngIf="fd.value | isNotNullNorUndefinedNorWhiteString"
        [appearance]="appearanceInputMaterial"
        [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
        solidifyTooltipOnEllipsis
      >
        <mat-label>{{labelTranslateEnum.reasonForRejection | translate }}</mat-label>
        <textarea [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
                  cdkAutosizeMaxRows="10"
                  cdkAutosizeMinRows="5"
                  cdkTextareaAutosize
                  matInput
        ></textarea>
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>
    </ng-container>

  </ng-template>

  <ng-template #rightTemplate>

    <solidify-file-upload-input-container *ngIf="model?.signedDuaFile | isNotNullNorUndefined"
                                          [backendFileAdapter]="dataFileAdapter"
                                          [readonly]="true"
                                          [uploadButtonLabelToTranslate]="labelTranslateEnum.duaFile"
                                          [titleToTranslate]="labelTranslateEnum.duaFile"
                                          [backendFile]="model?.signedDuaFile"
                                          [resourceId]="model?.resId"
                                          [resourceFileNameSpace]="sharedNotificationActionNameSpace"
                                          [blobProvidedMode]="'RETRIEVE_BY_STORE'"
                                          class="file-upload"
    ></solidify-file-upload-input-container>

    <ng-container *ngIf="getFormControl(formDefinition.objectId) as fd">
      <ng-container *ngIf="getFormControl(formDefinition.notificationType).value as currentType">
        <ng-container [ngSwitch]="currentType">

          <mat-form-field *ngSwitchCase="notificationTypeEnum.CREATE_ORGUNIT_REQUEST"
                          [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{labelTranslateEnum.desiredOrganizationalUnitName | translate }}</mat-label>
            <input [formControl]="fd"
                   [required]="formValidationHelper.hasRequiredField(fd)"
                   [solidifyValidation]="errors"
                   matInput
            >
            <mat-error #errors
                       solidifyTooltipOnEllipsis
            ></mat-error>
          </mat-form-field>

          <mat-form-field *ngSwitchCase="notificationTypeEnum.JOIN_ORGUNIT_REQUEST"
                          [appearance]="appearanceInputMaterial"
                          [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                          solidifyTooltipOnEllipsis
          >
            <mat-label>{{labelTranslateEnum.desiredRole | translate }}</mat-label>
            <mat-select [solidifyDataTest]="dataTestEnum.sharedPersonOrgUnitRoleInputRole"
                        [formControl]="fd"
                        [required]="formValidationHelper.hasRequiredField(fd)"
            >
              <mat-option *ngFor="let role of listRole"
                          [solidifyDataTest]="role.resId"
                          [value]="role.resId"
                          solidifyTooltipOnEllipsis
              >
                {{role.name}}
              </mat-option>
            </mat-select>
          </mat-form-field>

          <ng-container *ngSwitchCase="currentType === notificationTypeEnum.VALIDATE_DEPOSIT_REQUEST || currentType === notificationTypeEnum.IN_ERROR_DEPOSIT_INFO ||
        currentType === notificationTypeEnum.CREATED_DEPOSIT_INFO ? currentType : ''"
          >
            <solidify-searchable-single-select (navigate)="navigateToDeposit($event)"
                                               [formControl]="fd"
                                               [isWithLink]="true"
                                               [labelKey]="'title'"
                                               [placeholder]="labelTranslateEnum.deposit | translate"
                                               [readonly]="true"
                                               [required]="formValidationHelper.hasRequiredField(fd)"
                                               [resourceNameSpace]="sharedDepositActionNameSpace"
                                               [state]="sharedDepositState"
                                               [valueKey]="'resId'"
                                               solidifyValidation
            >
            </solidify-searchable-single-select>
          </ng-container>

          <button (click)="goToAip()"
                  (onEnter)="goToAip()"
                  *ngSwitchCase="notificationTypeEnum.IN_ERROR_AIP_INFO"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeInStoragionInjectNumber | translate: {number: defaultAipStorage.name} }}
          </button>

          <button (click)="goToAipDownloaded()"
                  (onEnter)="goToAipDownloaded()"
                  *ngSwitchCase="notificationTypeEnum.IN_ERROR_DOWNLOADED_AIP_INFO"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeAipDownloaded | translate}}
          </button>

          <button (click)="goToDip()"
                  (onEnter)="goToDip()"
                  *ngSwitchCase="notificationTypeEnum.IN_ERROR_DIP_INFO"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeDip | translate}}
          </button>

          <button (click)="goToSip()"
                  (onEnter)="goToSip()"
                  *ngSwitchCase="notificationTypeEnum.IN_ERROR_SIP_INFO"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeSip | translate}}
          </button>

          <button (click)="goToAipSteward()"
                  (onEnter)="goToAipSteward()"
                  *ngSwitchCase="notificationTypeEnum.APPROVE_DISPOSAL_BY_ORGUNIT_REQUEST"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeAip | translate}}
          </button>

          <button (click)="goToArchive()"
                  (onEnter)="goToArchive()"
                  *ngSwitchCase="notificationTypeEnum.APPROVE_DISPOSAL_REQUEST"
                  solidifyAlternativeButton
                  solidifyShortCuts
          >
            {{labelTranslateEnum.seeArchive | translate}}
          </button>

          <div *ngSwitchCase="notificationTypeEnum.ACCESS_DATASET_REQUEST">
            <button (click)="goToArchive()"
                    (onEnter)="goToArchive()"
                    solidifyAlternativeButton
                    solidifyShortCuts
            >
              {{labelTranslateEnum.seeArchive | translate}}
            </button>
          </div>
        </ng-container>
      </ng-container>
    </ng-container>

  </ng-template>


  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
